'
' Created by SharpDevelop.
' User: dj
' Date: 12/5/2009
' Time: 12:52 PM
' 
' To change this template use Tools | Options | Coding | Edit Standard Headers.
'

Public Partial Class RenardChipiplexerSetup
'	Private components As IContainer
	Private m_selectedPort As System.IO.Ports.SerialPort
	Private m_oktoclose As Boolean = True 'KLUDGE: there doesn't seem to be a ButtonClickEventArgs, so custom logic is needed in order to abort a button

#Region "Instantiation"
    Public Sub New(ByVal selectedPort As System.IO.Ports.SerialPort, ByVal protocolVersion As Integer, ByVal holdPort As Boolean, ByVal logfile As String, ByVal errpause As Boolean, ByVal trace As Boolean, ByVal cfg As Byte, ByVal fullbright As Byte, ByVal maxbright As Byte, ByVal minbright As Byte, ByVal maxrpl As Integer, ByVal closeness As Byte, ByVal lossy As Boolean, ByVal dedup As Boolean, ByVal renbytes As Boolean, maxoutlen As Integer, ByRef rcvbuf As String)
		' The Me.InitializeComponent call is required for Windows Forms designer support.
		Me.InitializeComponent()
		
		Me.m_selectedPort = selectedPort
		Me.comboBoxProtocolVersion.SelectedIndex = (protocolVersion - 1)
		Me.checkBoxHoldPort.Checked = holdPort
'		Me.checkBoxDataLog.Checked = Not String.IsNullOrEmpty(logfile)
		Me.logFileTextBox.Text = logfile
		Me.pauseOnErrorCheckBox.Checked = errpause
		Me.dataLoggingCheckBox.Checked = trace
		Me.configByteMaskedTextBox.Text = cfg
		Me.rowsPerLevelNumericUpDown.Value = maxrpl
		Me.minBrightNumericUpDown.Value = minbright
		Me.maxBrightNumericUpDown.Value = maxbright
		Me.fullBrightNumericUpDown.Value = fullbright
		Me.lossyCheckBox.Checked = lossy
		Me.dedupNumericUpDown.Value = dedup
		Me.closenessNumericUpDown.Value = closeness
		Me.renardDataCheckBox.Checked = renbytes
		Me.maxDataNumericUpDown.Value = maxoutlen
		Me.comboBoxProtocolVersion_SelectedIndexChanged(Me.comboBoxProtocolVersion, Nothing) 'set initial display state
		Me.consoleTextBox.Text = rcvbuf
	End Sub
#End Region

#Region "Generic Renard properties"
	Public ReadOnly Property HoldPort As Boolean
		Get
			Return Me.checkBoxHoldPort.Checked
		End Get
	End Property

	Public ReadOnly Property ProtocolVersion As Integer
		Get
			Return (Me.comboBoxProtocolVersion.SelectedIndex + 1)
		End Get
	End Property

	Public ReadOnly Property SelectedPort As System.IO.Ports.SerialPort
		Get
			Return Me.m_selectedPort
		End Get
	End Property

	Public ReadOnly Property PauseOnError As Boolean
		Get
			Return Me.pauseOnErrorCheckBox.Checked 
		End Get
	End Property
	
	Public ReadOnly Property DataLogging As Boolean
		Get
			Return Me.dataLoggingCheckBox.Checked 
		End Get
	End Property

	Public ReadOnly Property LogFile As String
		Get
			Return Me.logFileTextBox.Text
		End Get
	End Property
#End Region

#Region "Chipiplexing properties"
	Public ReadOnly Property ChipiplexingConfig As Byte
		Get
			Try
				Return Integer.Parse(Me.configByteMaskedTextBox.Text)
			Catch
				Return 0
			End Try
		End Get
	End Property
	
	Public ReadOnly Property ChipiplexingMaxRowsPerLevel As Byte
		Get
			Return Me.rowsPerLevelNumericUpDown.Value
		End Get
	End Property
	
	Public ReadOnly Property ChipiplexingMinBright As Byte
		Get
			Return Me.minBrightNumericUpDown.Value
		End Get
	End Property
	
	Public ReadOnly Property ChipiplexingMaxBright As Byte
		Get
			Return Me.maxBrightNumericUpDown.Value
		End Get
	End Property
	
	Public ReadOnly Property ChipiplexingFullBright As Byte
		Get
			Return Me.fullBrightNumericUpDown.Value
		End Get
	End Property
	
	Public ReadOnly Property ChipiplexingLossy As Boolean
		Get
			Return Me.lossyCheckBox.Checked
		End Get
	End Property
	
	Public ReadOnly Property ChipiplexingDedup As Integer
		Get
			Return Me.dedupNumericUpDown.Value
		End Get
	End Property
	
	Public ReadOnly Property ChipiplexingCloseness As Byte
		Get
			Return Me.closenessNumericUpDown.Value
		End Get
	End Property

	Public ReadOnly Property ChipiplexingRenBytes As Boolean
		Get
			Return Me.renardDataCheckBox.Checked
		End Get
	End Property

	Public ReadOnly Property ChipiplexingMaxOutlen As Integer
		Get
			Return Me.maxDataNumericUpDown.Value
		End Get
	End Property
#End Region

#Region "Event handlers"
	Private Sub buttonSerialSetup_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonSerialSetup.Click
		Dim ssdlg As New Vixen.Dialogs.SerialSetupDialog(Me.m_selectedPort)
		If (ssdlg.ShowDialog = Windows.Forms.DialogResult.OK) Then Me.m_selectedPort = ssdlg.SelectedPort
'use semi-dynamic binding, since the correct version of Vixen is not known at compile time:
'		Dim vixen As Reflection.Assembly = Reflection.Assembly.GetEntryAssembly 'GetCallingAssembly=mscorlib
'		Select Case vixen.GetName.Version.ToString
'			Case "2.1.1.0":
'				Dim ssdlg21 As Vixen21.Dialogs.SerialSetupDialog = Activator.CreateInstance(vixen.GetExportedTypes("SerialSetupDialog"), New Object(){Me.m_selectedPort})
'				If (ssdlg21.ShowDialog = Windows.Forms.DialogResult.OK) Then Me.m_selectedPort = ssdlg21.SelectedPort
'			Case "2.5.0.8":
'				Dim ssdlg25 As Vixen25.Dialogs.SerialSetupDialog = Activator.CreateInstance(vixen.GetExportedTypes("SerialSetupDialog"), New Object(){Me.m_selectedPort})
'				If (ssdlg25.ShowDialog = Windows.Forms.DialogResult.OK) Then Me.m_selectedPort = ssdlg25.SelectedPort
'			Case Else:
'				MsgBox("Unknown Vixen version: " & vixen.GetName.Version.ToString() & ".  Please contact the author of this plug-in for an update.")
'		End Select
	End Sub
	
	Private Sub form_closing(ByVal sender As Object, ByVal fcea As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
		If Not Me.m_oktoclose Then fcea.Cancel = True 'don't close yet
	End Sub

	Private Sub buttonOK_Click(ByVal sender As Object, ByVal ea As EventArgs) Handles buttonOK.Click
		Try
			Me.m_oktoclose = True 'assume it's okay to close until found otherwise
			If Not Me.MinMaxCheck("Full bright", Me.fullBrightNumericUpDown, 255, 64) Then Me.m_oktoclose = False
			If Not Me.MinMaxCheck("Max bright", Me.maxBrightNumericUpDown, Me.fullBrightNumericUpDown.Value, 64) Then Me.m_oktoclose = False
			If Not Me.MinMaxCheck("Min bright", Me.minBrightNumericUpDown, Me.maxBrightNumericUpDown.Value, 1) Then Me.m_oktoclose = False
			If Not Me.MinMaxCheck("Max rows per level", Me.rowsPerLevelNumericUpDown, 8, 1) Then Me.m_oktoclose = False
			If Not Me.MinMaxCheck("Closeness", Me.closenessNumericUpDown, 32, 1) Then Me.m_oktoclose = False
			If Not Me.MinMaxCheck("Max out len", Me.maxDataNumericUpDown, 200, 30) Then Me.m_oktoclose = False
		Catch exc As Exception
			Me.m_oktoclose = False 'don't allow form to close
			MsgBox(exc, MsgBoxStyle.ApplicationModal + MsgBoxStyle.Exclamation, "ERROR")
		End Try
	End Sub

	Private Sub fileBrowseButton_Click(ByVal sender As Object, ByVal ea As EventArgs) Handles fileBrowseButton.Click
'		If (ssdlg.ShowDialog = Windows.Forms.DialogResult.OK) Then Me.m_selectedPort = ssdlg.SelectedPort
		Me.openFileDialog.FileName = Me.logFileTextBox.Text
		If Me.openFileDialog.ShowDialog = Windows.Forms.DialogResult.OK Then
			Me.logfiletextbox.Text = Me.openFileDialog.FileName 
			If Not String.IsNullOrEmpty(Me.logFileTextBox.Text) Then Me.dataLoggingCheckBox.Checked = True
		End If
	End Sub

	Private Sub comboBoxProtocolVersion_SelectedIndexChanged(ByVal sender As Object, ByVal ea As EventArgs) Handles comboBoxProtocolVersion.SelectedIndexChanged 
		Me.Width = IIf(Me.ProtocolVersion = 3, 575, 289)
		Me.Height = IIf(Me.ProtocolVersion = 3, 272, 224)
		Me.consoleLabel.Visible = (Me.ProtocolVersion = 3)
	End Sub
#End Region

#Region "Helpers"
'verify that a value is within range:
	Private Function MinMaxCheck(ByVal desc As String, ByRef nud As System.Windows.Forms.NumericUpDown, ByVal maxval As Integer, ByVal minval As Integer) As Boolean
		If nud.value > maxval Then
			MsgBox(String.Format("{0} ({1}) cannot be more than {2}.", desc, nud.value, maxval), MsgBoxStyle.Exclamation + MsgBoxStyle.ApplicationModal, "ERROR")
			nud.value = maxval
			Return False
		End If
		If nud.value < minval Then
			MsgBox(String.Format("{0} ({1}) should be at least {2}.", desc, nud.value, minval), MsgBoxStyle.Exclamation + MsgBoxStyle.ApplicationModal, "ERROR")
			nud.value = minval
			Return False
		End If
		Return True
	End Function
#End Region
End Class
